with Moviments; use Moviments;
with InteligenciaArtificial; use InteligenciaArtificial;

package body ComecocosPack is

  ----------- TASKA COORDINADOR ------------
  task body Coordinador is
    M: Moviment;
    D: Direccio;
    Obstacles, Menjacocos, Ous, Vitamines, Cocos: LPosicions.Llista;
    OuPos, OuProxim, VitaminaProxima, VitaminaPos, CocoPos, CocoProxim: posicio;
    Controller: PControl;
    incubado: boolean := false;
    permisMoviments: boolean := true;
    acabar, vacio: boolean := false;
    Dnord, Dsud, Dest, Doest: boolean := false;
    DestiTrobat: boolean := false;
    primeraVueltaS, primeraVueltaP: boolean := true;
    DistanciaSorAssig, DistanciaPistaAssig: integer;
    AssignatPistaID, AssignatPrimerPistaID, AssignatSorpresaID, AssignatPrimerSorpresaID : posicio;
    AssignatPista, AssignatSorpresa : boolean := false;
    StatusAtrapat : boolean := false;
  begin
    -- Hasta que no nos asignen un Control no podemos iniciarnos
    accept SetControl(Ctrl: PControl) do
      Controller := Ctrl;
    end SetControl;

    loop
      -- Esperamos a que nos dejen empezar
      accept start do
        null;
      end start;
      
      
      
      while not (acabar) loop
        select
          -- Aceptamos llamadas de los comecocos que desean moverse (nos envian
          -- parametros extra por si hubiese que crear un nuevo comecocos despues de
          -- una incubacin).
          accept donde_mov(veryOldP, oldP: in Posicio; P: out Posicio; Duracion: in PDuration; Periodo: in Time_Span) do

            -- Si ens han tret el permis de moviments significa que el sistema s'est aturant.
            -- Com que en aquesta situaci no cridarem a Control per crear nous menjacocos
            -- evitarem un DeadLock entre Control - Comecocos - Coordinador
            if (permisMoviments) then
              DestiTrobat := false;
  
              ------ PRIMERA FASE ------
              -- Si la primera fase no encuentra un destino, se busca en la segunda.
              --------------------------
              -- Si hay sorpresa y no estamos en la situacin en la que no hay pista
              -- y la sorpresa es mala (Si no hay pista es que la hemos cogido, y
              -- si a pesar de cogerla seguimos pensando que es mala, no ir a por la sorpresa)
              if (Hi_Ha_Sorpresa(T.ALL) and not (not (Hi_Ha_Pista(T.ALL)) and SorpresaDolenta(T.ALL)) ) then

                -- Una vez aparecida la sorpresa, se asigna como objetivo del primer
                -- comecoco que solicita movimiento. Si durante las proximas peticiones
                -- de los demas comecocos encontramos uno mas cercano a la pista/sorpresa
                -- se reasigna el objetivo al nuevo. Pararemos de reasignar una vez
                -- nos hayan preguntado todos los comecocos, o lo que es lo mismo
                -- hasta que el primer comecoco que le asignamos el objetivo nos pregunte de nuevo.
                -- A esto lo llamaremos Vuelta.
                if (AssignatPrimerSorpresaID = oldP) and (primeraVueltaS) then
                  primeraVueltaS := false;
                elsif (AssignatPrimerPistaID = oldP) and (primeraVueltaP) then
                  primeraVueltaP := false;
                end if;
                -- Si hay 1 o 2 comecocos, solo dedicaremos 1 que vaya a buscar
                -- la pista y luego otro (si la pista es positiva) que busque la sorpresa.
                -- El que quede se dedicar a llevar a cabo las misiones de la FASE 2
                if (Total_Menjacocos(T.ALL) <= 2) then
                  if (Hi_Ha_Pista(T.ALL)) and (AssignatPista)  then
                    -- Es el comecoco asignado a la pista
                    if (AssignatPistaID = oldP) then
                      DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Pista(T.ALL), P);
                      DistanciaPistaAssig := h(P, Posicio_Pista(T.ALL));
                      DestiTrobat := true;  -- No hace falta entrar en la segunda fase
                      AssignatPistaID := P;
                    -- Si este comecoco esta mas cerca que el comecoco asignado y
                    -- es todavia la primera vuelta. 
                    elsif (h(oldP, Posicio_Pista(T.ALL)) < DistanciaPistaAssig) and (primeraVueltaP) then
                      -- Reasignamos comecoco a la pista
                      DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Pista(T.ALL), P);
                      DistanciaPistaAssig := h(P, Posicio_Pista(T.ALL));
                      DestiTrobat := true; -- No hace falta entrar en la segunda fase
                      AssignatPistaID := P;
                      AssignatPista := true;
                    end if;
                  elsif (Hi_Ha_Pista(T.ALL)) and not (AssignatPista) then
                    -- Assignamos comecoco a la pista
                    DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Pista(T.ALL), P);
                    DistanciaPistaAssig := h(P, Posicio_Pista(T.ALL));
                    DestiTrobat := true; -- No hace falta entrar en la segunda fase
                    AssignatPistaID := P;
                    AssignatPista := true;
                    AssignatPrimerPistaID := AssignatPistaID;
                    primeraVueltaP := true;
                  elsif not (SorpresaDolenta(T.ALL)) and (AssignatSorpresa) then
                    -- Es el comecoco asignado a la sorpresa
                    if (AssignatSorpresaID = oldP) then 
                      AssignatPista := false;
                      DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Sorpresa(T.ALL), P);
                      DistanciaSorAssig := h(P, Posicio_Sorpresa(T.ALL));
                      DestiTrobat := true; -- No hace falta entrar en la segunda fase
                      AssignatSorpresaID := P;
                    -- Si este comecoco esta mas cerca que el comecoco asignado y
                    -- es todavia la primera vuelta. 
                    elsif (h(oldP, Posicio_Sorpresa(T.ALL)) < DistanciaSorAssig) and (primeraVueltaS) then
                      -- Reasignamos comecocos a la sorpresa
                      AssignatPista := false;
                      AssignatSorpresa := true;
                      DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Sorpresa(T.ALL), P);
                      DistanciaSorAssig := h(P, Posicio_Sorpresa(T.ALL));
                      DestiTrobat := true; -- No hace falta entrar en la segunda fase
                      AssignatSorpresaID := P;
                    end if;
                  elsif not (SorpresaDolenta(T.ALL)) and not (AssignatSorpresa) then
                    -- Asignamos comecocos a la sorpresa por primera vez
                    AssignatPista := false;
                    AssignatSorpresa := true;
                    DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Sorpresa(T.ALL), P);
                    DistanciaSorAssig := h(P, Posicio_Sorpresa(T.ALL));
                    DestiTrobat := true; -- No hace falta entrar en la segunda fase
                    AssignatSorpresaID := P;
                    AssignatPrimerSorpresaID := AssignatSorpresaID;
                    primeraVueltaS := true;
                  else
                    AssignatPista := false;
                  end if;
                else  -- Tenemos mas de 2 comecocos, asignamos 2 que vayan en paralelo a por la pista/sorpresa
                  -- El resto de comecocos llevaran a cabo las misiones de la FASE 2.
                  
                  -- La funcion --DonarUnPas no se pondra encima de una sorpresa si
                  -- es mala o todavia no se sabe.
                  if (Hi_Ha_Pista(T.ALL)) and (AssignatPista) then 
                    if AssignatPistaID = oldP then
                      -- Es el comecoco asignado a la pista
                      DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Pista(T.ALL), P);
                      DestiTrobat := true; -- No hace falta entrar en la segunda fase
                      AssignatPistaID := P;
                    -- Si este comecoco esta mas cerca que el comecoco asignado y
                    -- es todavia la primera vuelta. 
                    elsif (h(oldP, Posicio_Pista(T.ALL)) < DistanciaPistaAssig) and (oldP/=AssignatSorpresaID) and (primeraVueltaP) then
                      -- Reasignamos comecoco a la pista
                      DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Pista(T.ALL), P);
                      DistanciaPistaAssig := h(P, Posicio_Pista(T.ALL));
                      DestiTrobat := true; -- No hace falta entrar en la segunda fase
                      AssignatPistaID := P;
                      AssignatPista := true;
                    end if;
                  elsif (Hi_Ha_Pista(T.ALL)) and not (AssignatPista) then
                    -- Asignamos comecoco a la pista por primera vez
                    DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Pista(T.ALL), P);
                    DistanciaPistaAssig := h(P, Posicio_Pista(T.ALL));
                    DestiTrobat := true; -- No hace falta entrar en la segunda fase
                    AssignatPistaID := P;
                    AssignatPista := true;
                    AssignatPrimerPistaID := AssignatPistaID;
                    primeraVueltaP := true;
                  end if;
                  
                  if (AssignatSorpresa) and not(DestiTrobat) then
                    if (AssignatSorpresaID = oldP) then
                      -- Es el comecoco asignado a la sorpresa
                      DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Sorpresa(T.ALL), P);
                      DestiTrobat := true; -- No hace falta entrar en la segunda fase
                      AssignatSorpresaID := P;
                    -- Si este comecoco esta mas cerca que el comecoco asignado y
                    -- es todavia la primera vuelta. 
                    elsif (h(oldP, Posicio_Sorpresa(T.ALL)) < DistanciaSorAssig) and (primeraVueltaS) then
                      -- Reasignamos comecoco a la sorpresa
                      AssignatSorpresa := true; -- No hace falta entrar en la segunda fase
                      DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Sorpresa(T.ALL), P);
                      DistanciaSorAssig := h(P, Posicio_Sorpresa(T.ALL));
                      DestiTrobat := true;
                      AssignatSorpresaID := P;
                    end if;
                  elsif not (AssignatSorpresa) and not(DestiTrobat) then
                    -- Asignamos comecoco a la sorpresa por primera vez
                    AssignatSorpresa := true; -- No hace falta entrar en la segunda fase
                    DonarUnPas(T.ALL, veryOldP, oldP, Posicio_Sorpresa(T.ALL), P);
                    DistanciaSorAssig := h(P, Posicio_Sorpresa(T.ALL));
                    DestiTrobat := true;
                    AssignatSorpresaID := P;
                    AssignatPrimerSorpresaID := AssignatSorpresaID;
                    primeraVueltaS := true;
                  end if;
                end if;
              else
                -- No hay sorpresa, por tanto desassignamos si habia alguien assignado.
                AssignatPista := false;
                AssignatSorpresa := false;
              end if;
              
              ------ SEGUNDA FASE ------
              -- Si la primera fase no encuentra un destino, se busca en la segunda
              --------------------------
              if not (DestiTrobat) then

                -- Prioridad 1: ir a por los huevos. Entre ms incubemos
                -- mas comecocos habr y ms posibilidades de ganar puntos.
                Posicions_Ous(T.ALL, Ous);
                LPosicions.Primer(Ous);
                
                vacio := true;  -- OuProxim buit
                if (LPosicions.Queden(Ous)) then
                  -- Buscamos el huevo ms proximo a este comecoco
                  while (LPosicions.Queden(Ous)) loop
                    OuPos := LPosicions.Actual(Ous);
                    if (vacio) then
                      OuProxim := OuPos;
                      vacio := false;
                    else
                      -- h es ms pequeo contra ms cerca
                      if h(oldP, OuPos) < h(oldP, OuProxim) then
                        OuProxim := OuPos;
                      end if;
                    end if;
                    LPosicions.Seguent(Ous);
                  end loop;

                  DonarUnPas(T.ALL, veryOldP, oldP, OuProxim, P);
                else
                  -- Prioridad 2: ir a por las vitaminas. Tienen mayor valor
                  -- que los cocos, es recomendable cogerlas antes de que se
                  -- acabe el tiempo.
                  Posicions_Vitamines(T.ALL, Vitamines);
                  LPosicions.Primer(Vitamines);
                  if (LPosicions.Queden(Vitamines)) then
                    vacio := true;  -- VitaminaProxima buit
                    -- Buscamos la vitamina ms proximo a este comecoco
                    while (LPosicions.Queden(Vitamines)) loop
                      VitaminaPos := LPosicions.Actual(Vitamines);
                      if (vacio) then
                        VitaminaProxima := VitaminaPos;
                        vacio := false;
                      else
                        -- h es ms pequeo contra ms cerca
                        if h(oldP, VitaminaPos) < h(oldP, VitaminaProxima) then
                          VitaminaProxima := VitaminaPos;
                        end if;
                      end if;
                      LPosicions.Seguent(Vitamines);
                    end loop;
                    
                    DonarUnPas(T.ALL, veryOldP, oldP, VitaminaProxima, P);
                  else
                    -- Prioridad 3: ir a por los cocos. 
                    Posicions_Cocos(T.ALL, Cocos);
                    LPosicions.Primer(Cocos);
                    if (LPosicions.Queden(Cocos)) then
                      vacio := true;  -- CocoProxim buit
                      -- Buscamos la vitamina ms proximo a este comecoco
                      while (LPosicions.Queden(Cocos)) loop
                        CocoPos := LPosicions.Actual(Cocos);
                        if (vacio) then
                          CocoProxim := CocoPos;
                          vacio := false;
                        else
                          -- h es ms pequeo contra ms cerca
                          if h(oldP, CocoPos) < h(oldP, CocoProxim) then
                            CocoProxim := CocoPos;
                          end if;
                        end if;
                        LPosicions.Seguent(Cocos);
                      end loop;
                    
                      DonarUnPas(T.ALL, veryOldP, oldP, CocoProxim, P);
                    else
                      -- Prioridad Nula: ya no quedan ni huevos ni vitaminas, los
                      -- comecocos se moveran aleatoriamente por el tablero sin
                      -- comer ninguna sorpresa que sea mala.
                    
                      Posicions_Obstacles(T.ALL, Obstacles);
                      Posicions_Menjacocos(T.ALL, Menjacocos);
                      -- Movimiento aleatorio que si sobrepasa un borde del tablero aparece
                      -- por el otro. Si en la nueva posicio hay un obstaculo o comecoco se
                      -- vuelve a calcular otra posicion.
                      loop
                        -- Si ja hem generat totes les direccions possibles i cap es valida
                        -- sortir
                        if ((Dnord) and (Dsud) and (Dest) and (Doest)) then
                          P.Fil := oldP.Fil;  -- No ens podem moure
                          P.Col := oldP.Col;
                          exit;
                        end if;
                      
                        D:=Moviment_Aleatori(M);
            
                        if D=Nord then
                          Dnord := true;
                          if (oldP.Fil-1) < 1 then
                            P.Fil:=Obtenir_Num_Fileres(T.ALL);
                          else
                            P.Fil:= oldP.Fil-1;
                          end if;
                          P.Col:= oldP.Col;
                        
                        elsif D=Sud then
                          Dsud := true;
                          if (oldP.Fil+1) > Obtenir_Num_Fileres(T.ALL) then
                            P.Fil:=1;
                          else
                            P.Fil:= oldP.Fil+1;
                          end if;
                          P.Col:= oldP.Col;
                        
                        elsif D=Est then
                          Dest := true;
                          if (oldP.Col+1) > Obtenir_Num_Columnes(T.ALL) then
                            P.Col:=1;
                          else
                            P.Col:= oldP.Col+1;
                          end if;
                          P.Fil:= oldP.Fil;
            
                        elsif D=Oest then
                          Doest := true;
                          if (oldP.Col-1) < 1 then
                            P.Col:=Obtenir_Num_Columnes(T.ALL);
                          else
                            P.Col:= oldP.Col-1;
                          end if;
                          P.Fil:= oldP.Fil;
                        
                        end if;
                      
                      
                        exit when not (Hi_Ha_Sorpresa(T.ALL) and SorpresaDolenta(T.ALL)
                                  and (P = Posicio_Sorpresa(T.ALL))) and
                                  (not LPosicions.Existeix(Obstacles, P)) and
                                  (not LPosicions.Existeix(Menjacocos, P));
                      end loop;
                      LPosicions.Alliberar_Memoria(Menjacocos);
                      LPosicions.Alliberar_Memoria(Obstacles);
                    end if;
                    LPosicions.Alliberar_Memoria(Cocos);
                  end if;
                  LPosicions.Alliberar_Memoria(Vitamines);
                end if;
                LPosicions.Alliberar_Memoria(Ous);
              end if;
              -- Modificamos el tablero, el cual se encarga de actualizar la pantalla
              -- Le pasamos tb el tiempo que ha tardado el comecoco en moverse
              -- para visualizarlo en Status
              Modificar_Menjacocos(T.ALL, oldP, P, incubado, Periodo);
              
              if (incubado) then
                -- Decir al Control que cree un nuevo comecoco
                Controller.ALL.create(oldP, Duracion, Periodo);
              end if;
              
              -- Re-inicializacin
              Dnord := false;
              Dsud := false;
              Dest := false;
              Doest := false;
              
            else
              -- Ens han tret el permis d'incubaci significa que el sistema s'est aturant
              -- per tant no cal que fem cap movimient de menjacocos.
              P:=oldP;
            end if;
          end donde_mov;
        or
          -- Si nos ordenan acabar, salimos
          accept theEnd do
            acabar := true;
          end theEnd;
        or
          -- Nos quitan el permiso para mover a los comecocos
          accept noMove do
            permisMoviments := false;
          end noMove;
        end select; 
      end loop;
      
      -- Re-inicializacin
      acabar:=false;
      permisMoviments := true;
    end loop;
  end Coordinador;
  ----------- TASKA COORDINADOR FIN ------------
  
  ----------- TASKA CONTROL ------------
  task body Control is
    CC: PComecocos;
    PP: PPosicio;
    CoordParado: boolean := true;
    CCnoIncubados: integer;
    primerInicio: boolean := true;
    i: integer;
  begin
    loop
      select
        accept start do
          -- En la primera ejecucin guardamos el numero de comecocos iniciales
          -- que tenemos. Asi sabremos a partir de que punto son comecocos creados
          -- por incubacin.
          if (primerInicio) then
            CCnoIncubados := Total(Llistat.ALL);
            primerInicio := false;
          end if;
          
          -- Iniciamos coordinador que da servicios a los comecocos
          Coord.ALL.start;
          -- Ordenamos iniciarse a todos los comecocos iniciales (no incubados)
          Primer(Llistat.ALL);
          for i in 0..CCnoIncubados-1 loop
            CC := Actual(Llistat.ALL);
            CC.ALL.start;
            Seguent(Llistat.ALL);
          end loop;
          -- Iniciamos sorpresas
          Sorpreses.ALL.start;          
          -- Si hay en la lista comecocos incubados, los eliminamos pues solo
          -- son validos durante 1 partida.
          while Queden(Llistat.ALL) loop
            Esborrar(Llistat.ALL);
          end loop;
          
          -- Finalmente iniciamos la limpieza de huevos y vitaminas inaccesibles
          -- Lo realizamos al final para no colapsar la ejecucin del juego a la
          -- espera de la limpieza.
          GarbageCleaner.ALL.start;
        end Start;
      or
        accept theEnd do
          -- Ordenamos pararse a todos los comecocos
          Primer(Llistat.ALL);
          while Queden(Llistat.ALL) loop
            CC := Actual(Llistat.ALL);
            CC.ALL.theEnd;
            Seguent(Llistat.ALL);
          end loop;
          -- Paramos sorpresas
          Sorpreses.ALL.theEnd;
          -- Una vez parados todos podemos indicarle al coordinador que
          -- deje de servir
          Coord.ALL.theEnd;

          -- Antes de resetear el tablero hay que assegurarse que Cleaner esta
          -- parado, sino podrian producirse problemas
          GarbageCleaner.ALL.theEnd;
          Reset(T.ALL);
        end theEnd;
      or
        accept create(Pos: in Posicio; Duracion: in PDuration; Periodo: in Time_Span) do
          -- Utilizamos PP para poder crear el comecocos (ya que necesita
          -- que le pasemos punteros)
          PP:= new Posicio;
          PP.ALL := Pos;
          CC:= new Comecocos(Coord, PP, Duracion, true);
                                            -- true = comecoco incubado
          -- Ens assegurem que esta al final
          while Queden(Llistat.ALL) loop
            Seguent(Llistat.ALL);
          end loop;
          Afegir(Llistat.ALL, CC);  -- Lo aadimos a la lista interna del control
          Afegir_Menjacocos(T.ALL, Pos, true);  -- Lo aadimos a la lista del tablero para que lo visualice
                                                -- true = comecoco incubado
          CC.ALL.start; -- Ya puede iniciarse
        end create;
      end select;
    end loop;
  end;
  ----------- TASKA CONTROL FIN ------------
  
  ----------- TASKA COMECOCOS ------------
  task body Comecocos is
    iniP, miP, newP, oldP: Posicio;
    acabar: boolean := false;
    T0, T1: Time; -- Pel calcul del temps entre moviments
    Periodo: Time_Span := Time_Span_Zero;
    CoordT0, CoordT1: Time; -- Pel calcul del temps que triga en respondre el coord.
  begin
    iniP := P.ALL;
    loop
      -- Esperamos a que nos dejen comenzar
      accept start do
        null;
      end start;
      
      miP := iniP;  -- Inicializamos nuestra posicion actual a la inicial
      oldP := iniP;
      while not (acabar) loop
        T0 := Clock;
        CoordT0 := Clock;
        C.ALL.donde_mov(oldP, miP, newP, Duracion, Periodo);  -- Parametros extras por si ha incubado
                                                           -- y el tiempo que ha tardado en moverse
                                                           -- para visualizarlo en Status
        CoordT1 := Clock;
        
        -- Si nos ordenan acabar, salimos
        select
          accept theEnd do
            acabar := true;
          end theEnd;
        or
          -- Al tiempo minimo que el comecoco debe estar sin moverse, le restamos
          -- el tiempo que hemos perdido ya con el coordinador. Entre ms tarde
          -- el coordinador en responder, ms se nota esta optimizacin.
          delay (Duracion.ALL - To_Duration(CoordT1 - CoordT0));
        end select;
        
        oldP := miP;
        miP := newP;
        T1 := Clock;
        Periodo := T1 - T0;
      end loop;
      
      acabar:=false;
      -- Si se trata de un comecoco creado por incubacin, ya puede finalizar
      -- su ejecucin ya que solo es vlido durante una partida.
      exit when (incubado);
    end loop;
  end Comecocos;
  ----------- TASKA COMECOCOS FIN ------------


end ComecocosPack;
