with Parametros; use Parametros;

package body InteligenciaArtificial is

  Infinit: Constant integer:= 100000;
  MenysInfinit: Constant integer:= -100000;

  -----------------------------------------------
  ------------ RUTINAS DE DARUNPASO -------------
  -----------------------------------------------

  
  -- Funcin Heurstica. Da Valores altos si P0 se encuentra proximo a P1.
  function h(P0, P1: Posicio) return integer is
  begin
    return ((P0.Col-P1.Col)*(P0.Col-P1.Col)  + (P0.Fil-P1.Fil)*(P0.Fil-P1.Fil) );
  end h;
  
  -- A partir d'una posici construieix tots el recurreguts possibles fins a donar
  -- "NivellMaxim" pasos, o fins arribar al dest (si el cam no es bo tb s'atura).
  -- De tots els camins generats valora la posici a on ens quedem y selecciona
  -- el valor ms elevat.
  -- Es valorar ms al cam que arribi al dest de forma ms rpida. Per aix
  -- a la funci heurstica restem el nombre de nivell
  --
  -- Parametres: Llista obstacles, nombre maxim de Fileres i columens, Posici
  -- inicial y final, nivell (nombre de pasos donats), valor del cam que estem
  -- seguint, ultima direcci agafada (0 = est, 1 = oest, 2 = sud, 3 = nord).
  procedure Recorregut(Obstacles: in out LPosicions.Llista; HiHaSorpresaDolenta: in boolean; SorpresaPos: in posicio; Fil, Col: integer; PosIni, PosDesti: in Posicio; Nivell: in integer; Valor: out integer; Anterior, Pasos: in integer) is
    NovaPos: Posicio;
    ValorEst, ValorOest, ValorSud, ValorNord: integer;
    camiTrobat: boolean := false;
  begin
    -- Si ya hem donat el nombre mxim de passos, valorem la posici a on estem
    if (Nivell = Pasos) then
      Valor := Infinit/2 - h(PosIni, PosDesti) - Nivell + 1;
    else

      camiTrobat := false;
      -- Si venim de l'oest no fem cap calcul, no hem de tornar mai enrera
      if (Anterior /= 1) and not (camiTrobat) then
        NovaPos := PosIni;
        -- Direcci EST
        -- Controlem els limits del tauler
        if ((NovaPos.Col + 1) > Col) then
          NovaPos.Col := 1;
        else 
          NovaPos.Col := NovaPos.Col + 1;
        end if;
        
        if (not (LPosicions.Existeix(Obstacles, NovaPos)) and not (NovaPos = PosDesti)) then
          -- Si hi ha sorpresa dolenta i no esta al nostre cami
          if (HiHaSorpresaDolenta) and (NovaPos = SorpresaPos) then
            -- Calcul del valor del fill
            Recorregut(Obstacles, HiHaSorpresaDolenta, SorpresaPos, Fil, Col, NovaPos, PosDesti, Nivell+1, ValorEst, 0, Pasos);
            -- Si es troba aprop es ms dolent pq hi ha menys temps per que desapareixi
            ValorEst := ValorEst - 2;
          else
            -- Calcul del valor del fill
            Recorregut(Obstacles, HiHaSorpresaDolenta, SorpresaPos, Fil, Col, NovaPos, PosDesti, Nivell+1, ValorEst, 0, Pasos);
          end if;
        elsif (NovaPos = PosDesti) then
          ValorEst := Infinit - Nivell + 1;
          camiTrobat := True;
        else
          ValorEst := MenysInfinit;
        end if;
      else
        ValorEst := MenysInfinit;
      end if;
      
      
      -- Si venim de l'est no fem cap calcul, no hem de tornar mai enrera
      -- I si ja hem trobat un cami deixem de calcular,  com que sempre cridarem
      -- la funci sobre el menjacocos y l'objecte ms proper, no cal calcular +.
      if (Anterior /= 0) and not (camiTrobat) then
        NovaPos := PosIni;
        -- Direcci OEST
        -- Controlem els limits del tauler
        if ((NovaPos.Col - 1) < 1) then
          NovaPos.Col := Col;
        else
          NovaPos.Col := NovaPos.Col - 1;
        end if;
        if (not (LPosicions.Existeix(Obstacles, NovaPos)) and not (NovaPos = PosDesti)) then
          -- Si hi ha sorpresa dolenta i no esta al nostre cami
          if (HiHaSorpresaDolenta) and (NovaPos = SorpresaPos) then
            -- Calcul del valor del fill
            Recorregut(Obstacles, HiHaSorpresaDolenta, SorpresaPos, Fil, Col, NovaPos, PosDesti, Nivell+1, ValorOest, 1, Pasos);
            -- Si es troba aprop es ms dolent pq hi ha menys temps per que desapareixi
            ValorOest := ValorOest - 2;
          else
            -- Calcul del valor del fill
            Recorregut(Obstacles, HiHaSorpresaDolenta, SorpresaPos, Fil, Col, NovaPos, PosDesti, Nivell+1, ValorOest, 1, Pasos);
          end if;
        elsif (NovaPos = PosDesti) then
          ValorOest := Infinit - Nivell + 1;
          camiTrobat := True;
        else
          ValorOest := MenysInfinit;
        end if;
      else
        ValorOest := MenysInfinit;
      end if;


      -- Si venim del sud no fem cap calcul, no hem de tornar mai enrera
      -- I si ja hem trobat un cami deixem de calcular,  com que sempre cridarem
      -- la funci sobre el menjacocos y l'objecte ms proper, no cal calcular +.
      if (Anterior /= 3) and not (camiTrobat) then
        NovaPos := PosIni;
        -- Direcci SUD
        -- Controlem els limits del tauler
        if ((NovaPos.Fil + 1) > Fil) then
          NovaPos.Fil := 1;
        else
          NovaPos.Fil := NovaPos.Fil + 1;
        end if;
        if (not (LPosicions.Existeix(Obstacles, NovaPos)) and not (NovaPos = PosDesti))then
          -- Si hi ha sorpresa dolenta i no esta al nostre cami
          if (HiHaSorpresaDolenta) and (NovaPos = SorpresaPos) then
            -- Calcul del valor del fill
            Recorregut(Obstacles, HiHaSorpresaDolenta, SorpresaPos, Fil, Col, NovaPos, PosDesti, Nivell+1, ValorSud, 2, Pasos);
            -- Si es troba aprop es ms dolent pq hi ha menys temps per que desapareixi
            ValorSud := ValorSud - 2;
          else
            -- Calcul del valor del fill
            Recorregut(Obstacles, HiHaSorpresaDolenta, SorpresaPos, Fil, Col, NovaPos, PosDesti, Nivell+1, ValorSud, 2, Pasos);
          end if;
        elsif (NovaPos = PosDesti) then
          ValorSud := Infinit - Nivell + 1;
          camiTrobat := True;
        else
          ValorSud := MenysInfinit;
        end if;
      else
        ValorSud := MenysInfinit;
      end if;
      

      -- Si venim del nord no fem cap calcul, no hem de tornar mai enrera
      -- I si ja hem trobat un cami deixem de calcular,  com que sempre cridarem
      -- la funci sobre el menjacocos y l'objecte ms proper, no cal calcular +.
      if (Anterior /= 2) and not (camiTrobat) then
        NovaPos := PosIni;
        -- Direcci NORD
        -- Controlem els limits del tauler
        if ((NovaPos.Fil - 1) < 1) then
          NovaPos.Fil := Fil;
        else
          NovaPos.Fil := NovaPos.Fil - 1;
        end if;
        if (not (LPosicions.Existeix(Obstacles, NovaPos)) and not (NovaPos = PosDesti)) then
          -- Si hi ha sorpresa dolenta i no esta al nostre cami
          if (HiHaSorpresaDolenta) and (NovaPos = SorpresaPos) then
            -- Calcul del valor del fill
            Recorregut(Obstacles, HiHaSorpresaDolenta, SorpresaPos, Fil, Col, NovaPos, PosDesti, Nivell+1, ValorNord, 3, Pasos);
            -- Si es troba aprop es ms dolent pq hi ha menys temps per que desapareixi
            ValorNord := ValorNord - 2;
          else
            -- Calcul del valor del fill
            Recorregut(Obstacles, HiHaSorpresaDolenta, SorpresaPos, Fil, Col, NovaPos, PosDesti, Nivell+1, ValorNord, 3, Pasos);
          end if;
        elsif (NovaPos = PosDesti) then
          ValorNord := Infinit - Nivell + 1;
          camiTrobat := True;
        else
          ValorNord := MenysInfinit;
        end if;
      else
        ValorNord := MenysInfinit;
      end if;


      -- De tots els camns posibles, seleccionem el valor ms alt
      If (ValorEst >= ValorOest) and (ValorEst >= ValorSud) and (ValorEst >= ValorNord) then
        Valor := ValorEst;
      elsif (ValorOest >= ValorEst) and (ValorOest >= ValorSud) and (ValorOest >= ValorNord) then
        Valor := ValorOest;
      elsif (ValorSud >= ValorEst) and (ValorSud >= ValorOest) and (ValorSud >= ValorNord) then
        Valor := ValorSud;
      elsif (ValorNord >= ValorEst) and (ValorNord >= ValorOest) and (ValorNord >= ValorSud) then
        Valor := ValorNord;
      end if;
      
    end if;
    
  end Recorregut;
  
  
  
  -- A partir d'una posici inicial y un dest valor cada un dels pasos que pot
  -- donar i selecciona el millor.
  --
  -- Parametres: Tauler, ltima posici en la que estabem, posicio actual, posicio
  -- desti, posici a la que hem d'anar (resultat d'aplicar la funcio).
  procedure DonarUnPas(T: in out Tauler; PosAnt, PosIni, PosDesti: in Posicio; NovaPos: out Posicio) is
    Obstacles, Menjacocos: LPosicions.Llista;
    EstPos, OestPos, NordPos, SudPos, SorpresaPos: posicio;
    Est, Oest, Nord, Sud: integer;
    Fil, Col, Pasos: integer;
    HiHaSorpresa, SorDolenta: boolean;
  begin
    Posicions_Obstacles(T, Obstacles);
    Posicions_Menjacocos(T, Menjacocos);
    Fil := Obtenir_Num_Fileres(T);
    Col := Obtenir_Num_Columnes(T);
    HiHaSorpresa :=Hi_Ha_Sorpresa(T); 
    SorpresaPos := Posicio_Sorpresa(T);
    SorDolenta := SorpresaDolenta(T);
    
    Pasos := NivellMaxim;
    
    EstPos := PosIni;
    -- Direcci EST
    -- Controlem els limits del tauler
    if ((EstPos.Col + 1) > Col) then
      EstPos.Col := 1;
    else
      EstPos.Col := EstPos.Col + 1;
    end if;
    
    -- Si no anem cap a on veniem
    if (EstPos /= PosAnt) then
      -- Si a la nova posici hi ha un obstacle o menjacocos o 
      -- ja hem arribat al dest, no fem cap calcul.
      if not (LPosicions.Existeix(Obstacles, EstPos)) and
         not (LPosicions.Existeix(Menjacocos, EstPos)) and
         (EstPos /= PosDesti) then
        if (HiHaSorpresa) and (SorDolenta) then
          if (EstPos /= SorpresaPos) then
            Recorregut(Obstacles, true, SorpresaPos, Fil, Col, EstPos, PosDesti, 1, Est, 0, Pasos);
          else
            -- Anem cap a la sorpresa y es dolenta!
            Est := MenysInfinit - 1;
          end if;
        else
          Recorregut(Obstacles, false, SorpresaPos, Fil, Col, EstPos, PosDesti, 1, Est, 0, Pasos);
        end if;
      elsif not (LPosicions.Existeix(Menjacocos, EstPos)) and (EstPos = PosDesti) then
        if (HiHaSorpresa) and (SorDolenta) and (EstPos = SorpresaPos) then
          Est := MenysInfinit-1;  -- Hi ha una sorpresa dolenta o que encara desconeixem
        else
          Est := Infinit+1;
        end if;
      else
        Est := MenysInfinit-2; -- Hi ha un obstacle o menjacocos, mai escullir aquest cam
      end if;
    else
      Est := MenysInfinit; -- Escollir tornar d'on veniem si no hi ha altre alternativa
    end if;
    
    OestPos := PosIni;
    -- Direcci OEST
    -- Controlem els limits del tauler
    if ((OestPos.Col - 1) < 1) then
      OestPos.Col := Col;
    else
      OestPos.Col := OestPos.Col - 1;
    end if;
    
    -- Si no anem cap a on veniem
    if (OestPos /= PosAnt) then
      -- Si a la nova posici hi ha un obstacle o menjacocos o 
      -- ja hem arribat al dest, no fem cap calcul.
      if not (LPosicions.Existeix(Obstacles, OestPos)) and
         not (LPosicions.Existeix(Menjacocos, OestPos)) and
         (OestPos /= PosDesti) then
        if (HiHaSorpresa) and (SorDolenta) then
          if (OestPos /= SorpresaPos) then
            Recorregut(Obstacles, true, SorpresaPos, Fil, Col, OestPos, PosDesti, 1, Oest, 1, Pasos);
          else
            -- Anem cap a la sorpresa y es dolenta!
            Oest := MenysInfinit - 1;
          end if;
        else
          Recorregut(Obstacles, false, SorpresaPos, Fil, Col, OestPos, PosDesti, 1, Oest, 1, Pasos);
        end if;
      elsif not (LPosicions.Existeix(Menjacocos, OestPos)) and (OestPos = PosDesti) then
        if (HiHaSorpresa) and (SorDolenta) and (OestPos = SorpresaPos) then
          Oest := MenysInfinit-1; -- Hi ha una sorpresa dolenta o que encara desconeixem
        else
          Oest := Infinit+1;
        end if;
      else
        Oest := MenysInfinit-2; -- Hi ha un obstacle o menjacocos, mai escullir aquest cam
      end if;
    else
      Oest := MenysInfinit; -- Escollir tornar d'on veniem si no hi ha altre alternativa
    end if;
    
    SudPos := PosIni;
    -- Direcci SUD
    -- Controlem els limits del tauler
    if ((SudPos.Fil + 1) > Fil) then
      SudPos.Fil := 1;
    else
      SudPos.Fil := SudPos.Fil + 1;
    end if;
    
    -- Si no anem cap a on veniem
    if (SudPos /= PosAnt) then
      -- Si a la nova posici hi ha un obstacle o menjacocos o 
      -- ja hem arribat al dest, no fem cap calcul.
      if not (LPosicions.Existeix(Obstacles, SudPos)) and
         not (LPosicions.Existeix(Menjacocos, SudPos)) and
         (SudPos /= PosDesti) then
        if (HiHaSorpresa) and (SorDolenta) then
          if (EstPos /= SorpresaPos) then
            Recorregut(Obstacles, true, SorpresaPos, Fil, Col, SudPos, PosDesti, 1, Sud, 2, Pasos);
          else
            -- Anem cap a la sorpresa y es dolenta!
            Sud := MenysInfinit - 1;
          end if;
        else
          Recorregut(Obstacles, false, SorpresaPos, Fil, Col, SudPos, PosDesti, 1, Sud, 2, Pasos);
        end if;
      elsif not (LPosicions.Existeix(Menjacocos, SudPos)) and (SudPos = PosDesti) then
        if (HiHaSorpresa) and (SorDolenta) and (SudPos = SorpresaPos) then
          Sud := MenysInfinit-1; -- Hi ha una sorpresa dolenta o que encara desconeixem
        else
          Sud := Infinit+1;
        end if;
      else
        Sud := MenysInfinit-2; -- Hi ha un obstacle o menjacocos, mai escullir aquest cam
      end if;
    else
      Sud := MenysInfinit; -- Escollir tornar d'on veniem si no hi ha altre alternativa
    end if;
    
    NordPos := PosIni;
    -- Direcci NORD
    -- Controlem els limits del tauler
    if ((NordPos.Fil - 1) < 1) then
      NordPos.Fil := Fil;
    else
      NordPos.Fil := NordPos.Fil - 1;
    end if;
    
    -- Si no anem cap a on veniem
    if (NordPos /= PosAnt) then
      -- Si a la nova posici hi ha un obstacle o menjacocos o 
      -- ja hem arribat al dest, no fem cap calcul.
      if not (LPosicions.Existeix(Obstacles, NordPos)) and
         not (LPosicions.Existeix(Menjacocos, NordPos)) and
         (NordPos /= PosDesti) then
        if (HiHaSorpresa) and (SorDolenta) then
          if (EstPos /= SorpresaPos) then
            Recorregut(Obstacles, true, SorpresaPos, Fil, Col, NordPos, PosDesti, 1, Nord, 3, Pasos);
          else
            -- Anem cap a la sorpresa y es dolenta!
            Nord := MenysInfinit - 1;
          end if;
        else
          Recorregut(Obstacles, false, SorpresaPos, Fil, Col, NordPos, PosDesti, 1, Nord, 3, Pasos);
        end if;
      elsif not (LPosicions.Existeix(Menjacocos, NordPos)) and (NordPos = PosDesti) then
        if (HiHaSorpresa) and (SorDolenta) and (NordPos = SorpresaPos) then
          Nord := MenysInfinit-1; -- Hi ha una sorpresa dolenta o que encara desconeixem
        else
          Nord := Infinit+1;
        end if;
  
      else
        Nord := MenysInfinit-2; -- Hi ha un obstacle o menjacocos, mai escullir aquest cam
      end if;
    else
      Nord := MenysInfinit; -- Escollir tornar d'on veniem si no hi ha altre alternativa
    end if;

    If (Est > Oest) and (Est > Sud) and (Est > Nord) then
      NovaPos := EstPos;
    elsif (Oest >= Est) and (Oest >= Sud) and (Oest >= Nord) then
      NovaPos := OestPos;
    elsif (Sud >= Est) and (Sud >= Oest) and (Sud >= Nord) then
      NovaPos := SudPos;
    elsif (Nord >= Est) and (Nord >= Oest) and (Nord >= Sud) then
      NovaPos := NordPos;
    end if;
    
    -- Si per tots els camins hi ha obstacles y/o menjacocos y/o una sopresa
    -- que es dolenta o que encara no ho sabem.
    if (Est = Oest) and (Est = Sud) and (Est = Nord) and (Est < menysInfinit) then
      NovaPos := PosIni;  -- Ens quedem a la posici on estem.
    end if;

    -- Alliberam l'espai consumit
    LPosicions.Alliberar_Memoria(Menjacocos);
    LPosicions.Alliberar_Memoria(Obstacles);
  end DonarUnPas;


  ------------------------------------------------
  ----------- RUTINAS DE ESTAATRAPADO ------------
  ------------------------------------------------
  
  -- Avanza solo en todas las direccin resultates de la composicion Norte - Oeste
  procedure AtrapatNordOest(Obstacles: in out LPosicions.Llista; Fil, Col: integer; PosIni: in Posicio; Nivell: in integer; Valor: out integer; Pasos: in integer) is
    NovaPos: Posicio;
    ValorOest, ValorNord: integer;
    camiTrobat: boolean := false;
  begin
    -- Si ya hem donat el nombre mxim de passos, valorem la posici a on estem
    if (Nivell = Pasos) then
      Valor := Infinit;
    else
      
      NovaPos := PosIni;
      -- Direcci OEST
      -- Controlem els limits del tauler
      if ((NovaPos.Col - 1) < 1) then
        NovaPos.Col := Col;
      else
        NovaPos.Col := NovaPos.Col - 1;
      end if;
      
      if (LPosicions.Existeix(Obstacles, NovaPos)) then
        ValorOest := MenysInfinit;
      else
        AtrapatNordOest(Obstacles, Fil, Col, NovaPos, Nivell+1, ValorOest, Pasos);
      end if;
            

      NovaPos := PosIni;
      -- Direcci NORD
      -- Controlem els limits del tauler
      if ((NovaPos.Fil - 1) < 1) then
        NovaPos.Fil := Fil;
      else
        NovaPos.Fil := NovaPos.Fil - 1;
      end if;
      
      if (LPosicions.Existeix(Obstacles, NovaPos)) then
        ValorNord := MenysInfinit;
      else
        AtrapatNordOest(Obstacles, Fil, Col, NovaPos, Nivell+1, ValorNord, Pasos);
      end if;
      

      -- De tots els camns posibles, seleccionem el valor ms gran
      If (ValorNord>ValorOest) then
        Valor := ValorNord;
      else
        Valor := ValorOest;
      end if;
      
    end if;
    
  end AtrapatNordOest;
  
  -- Avanza solo en todas las direccin resultates de la composicion Norte - Este
  procedure AtrapatNordEst(Obstacles: in out LPosicions.Llista; Fil, Col: integer; PosIni: in Posicio; Nivell: in integer; Valor: out integer; Pasos: in integer) is
    NovaPos: Posicio;
    ValorEst, ValorNord: integer;
    camiTrobat: boolean := false;
  begin
    -- Si ya hem donat el nombre mxim de passos, valorem la posici a on estem
    if (Nivell = Pasos) then
      Valor := Infinit;
    else

      NovaPos := PosIni;
      -- Direcci EST
      -- Controlem els limits del tauler
      if ((NovaPos.Col + 1) > Col) then
        NovaPos.Col := 1;
      else 
        NovaPos.Col := NovaPos.Col + 1;
      end if;
      
      if (LPosicions.Existeix(Obstacles, NovaPos)) then
        ValorEst := MenysInfinit;
      else
        AtrapatNordEst(Obstacles, Fil, Col, NovaPos, Nivell+1, ValorEst, Pasos);
      end if;
      
      
      NovaPos := PosIni;
      -- Direcci NORD
      -- Controlem els limits del tauler
      if ((NovaPos.Fil - 1) < 1) then
        NovaPos.Fil := Fil;
      else
        NovaPos.Fil := NovaPos.Fil - 1;
      end if;
      
      if (LPosicions.Existeix(Obstacles, NovaPos)) then
        ValorNord := MenysInfinit;
      else
        AtrapatNordEst(Obstacles, Fil, Col, NovaPos, Nivell+1, ValorNord, Pasos);
      end if;
      

      -- De tots els camns posibles, seleccionem el valor ms gran
      If (ValorNord > ValorEst) then
        Valor := ValorNord;
      else
        Valor := ValorEst;
      end if;
      
    end if;
    
  end AtrapatNordEst;
  
  -- Avanza solo en todas las direccin resultates de la composicion Sur - Oeste
  procedure AtrapatSudOest(Obstacles: in out LPosicions.Llista; Fil, Col: integer; PosIni: in Posicio; Nivell: in integer; Valor: out integer; Pasos: in integer) is
    NovaPos: Posicio;
    ValorOest, ValorSud: integer;
    camiTrobat: boolean := false;
  begin
    -- Si ya hem donat el nombre mxim de passos, valorem la posici a on estem
    if (Nivell = Pasos) then
      Valor := Infinit;
    else
      
      
      NovaPos := PosIni;
      -- Direcci OEST
      -- Controlem els limits del tauler
      if ((NovaPos.Col - 1) < 1) then
        NovaPos.Col := Col;
      else
        NovaPos.Col := NovaPos.Col - 1;
      end if;
      
      if (LPosicions.Existeix(Obstacles, NovaPos)) then
        ValorOest := MenysInfinit;
      else
        AtrapatSudOest(Obstacles, Fil, Col, NovaPos, Nivell+1, ValorOest, Pasos);
      end if;

      
      NovaPos := PosIni;
      -- Direcci SUD
      -- Controlem els limits del tauler
      if ((NovaPos.Fil + 1) > Fil) then
        NovaPos.Fil := 1;
      else
        NovaPos.Fil := NovaPos.Fil + 1;
      end if;
      
      if (LPosicions.Existeix(Obstacles, NovaPos)) then
        ValorSud := MenysInfinit;
      else
        AtrapatSudOest(Obstacles, Fil, Col, NovaPos, Nivell+1, ValorSud, Pasos);
      end if;
      
      
      -- De tots els camns posibles, seleccionem el valor ms gran
      if (ValorSud > ValorOest) then
        Valor := ValorSud;
      else
        Valor := ValorOest;
      end if;
      
    end if;
    
  end AtrapatSudOest;
  
  
  -- Avanza solo en todas las direccin resultates de la composicion Sur - Este
  procedure AtrapatSudEst(Obstacles: in out LPosicions.Llista; Fil, Col: integer; PosIni: in Posicio; Nivell: in integer; Valor: out integer; Pasos: in integer) is
    NovaPos: Posicio;
    ValorEst, ValorSud: integer;
    camiTrobat: boolean := false;
  begin
    -- Si ya hem donat el nombre mxim de passos, valorem la posici a on estem
    if (Nivell = Pasos) then
      Valor := Infinit;
    else

      NovaPos := PosIni;
      -- Direcci EST
      -- Controlem els limits del tauler
      if ((NovaPos.Col + 1) > Col) then
        NovaPos.Col := 1;
      else 
        NovaPos.Col := NovaPos.Col + 1;
      end if;
      
      if (LPosicions.Existeix(Obstacles, NovaPos)) then
        ValorEst := MenysInfinit;
      else
        AtrapatSudEst(Obstacles, Fil, Col, NovaPos, Nivell+1, ValorEst, Pasos);
      end if;
      
      
      NovaPos := PosIni;
      -- Direcci SUD
      -- Controlem els limits del tauler
      if ((NovaPos.Fil + 1) > Fil) then
        NovaPos.Fil := 1;
      else
        NovaPos.Fil := NovaPos.Fil + 1;
      end if;
      
      if (LPosicions.Existeix(Obstacles, NovaPos)) then
        ValorSud := MenysInfinit;
      else
        AtrapatSudEst(Obstacles, Fil, Col, NovaPos, Nivell+1, ValorSud, Pasos);
      end if;
      

      -- De tots els camns posibles, seleccionem el valor ms gran
      If (ValorSud > ValorEst) then
        Valor := ValorSud;
      else
        Valor := ValorEst;
      end if;
      
    end if;
    
  end AtrapatSudEst;
  
  
  -- Comprueba que la PosIni es accesible. Devuelve true en Status de serlo o False
  -- de lo contrario.
  -- Para comprobarlo utiliza un algoritmo inteligente el cual a partir de la posicin
  -- da X pasos (establecidos en parametros.ads) hacia el exterior (nunca retrocediendo).
  -- Por eso se ha dividido la funcin de dar pasos en 4, para impedir que se vuelva atrs
  -- y de falsos negativos.
  -- Si todos sus caminos se ven obstaculizados por un obstaculo (valga la redundancia)
  -- se considerar inaccesible la posicin.
  procedure EstaAtrapat(T: in out Tauler; PosIni: in Posicio; Status: out boolean) is
    Obstacles: LPosicions.Llista;
    NovaPos: posicio;
    ValorEst1, ValorOest1, ValorSud1, ValorNord1, ValorEst2, ValorOest2, ValorSud2, ValorNord2: integer;
    Fil, Col, Pasos: integer;
  begin
    Posicions_Obstacles(T, Obstacles);

    Fil := Obtenir_Num_Fileres(T);
    Col := Obtenir_Num_Columnes(T);

    Pasos := NivellMaximAtrapat;
    
    NovaPos := PosIni;
    -- Direcci EST
    -- Controlem els limits del tauler
    if ((NovaPos.Col + 1) > Col) then
      NovaPos.Col := 1;
    else
      NovaPos.Col := NovaPos.Col + 1;
    end if;
    if (LPosicions.Existeix(Obstacles, NovaPos)) then
      ValorEst1 := MenysInfinit;
      ValorEst2 := MenysInfinit;
    else
      AtrapatNordEst(Obstacles, Fil, Col, NovaPos, 1, ValorEst1, Pasos);
      AtrapatSudEst(Obstacles, Fil, Col, NovaPos, 1, ValorEst2, Pasos);
    end if;
    
    NovaPos := PosIni;
    -- Direcci OEST
    -- Controlem els limits del tauler
    if ((NovaPos.Col - 1) < 1) then
      NovaPos.Col := Col;
    else
      NovaPos.Col := NovaPos.Col - 1;
    end if;
    if (LPosicions.Existeix(Obstacles, NovaPos)) then
      ValorOest1 := MenysInfinit;
      ValorOest2 := MenysInfinit;
    else
      AtrapatNordOest(Obstacles, Fil, Col, NovaPos, 1, ValorOest1, Pasos);
      AtrapatSudOest(Obstacles, Fil, Col, NovaPos, 1, ValorOest2, Pasos);
    end if;
    
    
    NovaPos := PosIni;
    -- Direcci SUD
    -- Controlem els limits del tauler
    if ((NovaPos.Fil + 1) > Fil) then
      NovaPos.Fil := 1;
    else
      NovaPos.Fil := NovaPos.Fil + 1;
    end if;
    if (LPosicions.Existeix(Obstacles, NovaPos)) then
      ValorSud1 := MenysInfinit;
      ValorSud2 := MenysInfinit;
    else
      AtrapatSudEst(Obstacles, Fil, Col, NovaPos, 1, ValorSud1, Pasos);
      AtrapatSudOest(Obstacles, Fil, Col, NovaPos, 1, ValorSud2, Pasos);
    end if;
    
    
    NovaPos := PosIni;
    -- Direcci NORD
    -- Controlem els limits del tauler
    if ((NovaPos.Fil - 1) < 1) then
      NovaPos.Fil := Fil;
    else
      NovaPos.Fil := NovaPos.Fil - 1;
    end if;
    if (LPosicions.Existeix(Obstacles, NovaPos)) then
      ValorNord1 := MenysInfinit;
      ValorNord2 := MenysInfinit;
    else
      AtrapatNordEst(Obstacles, Fil, Col, NovaPos, 1, ValorNord1, Pasos);
      AtrapatNordOest(Obstacles, Fil, Col, NovaPos, 1, ValorNord2, Pasos);
    end if;
    

    If ((ValorEst1 = MenysInfinit) and (ValorOest1 = MenysInfinit) and (ValorNord1 = MenysInfinit) and (ValorSud1 = MenysInfinit) and
        (ValorEst2 = MenysInfinit) and (ValorOest2 = MenysInfinit) and (ValorNord2 = MenysInfinit) and (ValorSud2 = MenysInfinit)) then
      Status := true;
    else
      Status := false;
    end if;
    
    -- Alliberam l'espai consumit
    LPosicions.Alliberar_Memoria(Obstacles);
  end EstaAtrapat;
end InteligenciaArtificial;
