with Posicions; use Posicions;
with Taulers; use Taulers;

package InteligenciaArtificial is

  -- A partir d'una posici inicial y un dest valor cada un dels pasos que pot
  -- donar i selecciona el millor.
  --
  -- Parametres: Tauler, ltima posici en la que estabem, posicio actual, posicio
  -- desti, posici a la que hem d'anar (resultat d'aplicar la funcio).
  procedure DonarUnPas(T: in out Tauler; PosAnt, PosIni, PosDesti: in Posicio; NovaPos: out Posicio);

  -- Comprueba que la PosIni es accesible. Devuelve true en Status de serlo o False
  -- de lo contrario.
  -- Para comprobarlo utiliza un algoritmo inteligente el cual a partir de la posicin
  -- da X pasos (establecidos en parametros.ads) hacia el exterior (nunca retrocediendo).
  -- Si todos sus caminos se ven obstaculizados por un obstaculo (valga la redundancia)
  -- se considerar inaccesible la posicin.
  procedure EstaAtrapat(T: in out Tauler; PosIni: in Posicio; Status: out boolean);
  
  -- Devuelve la distancia al cuadrado entre 2 posiciones
  function h(P0, P1: Posicio) return integer;
  
  
end InteligenciaArtificial;
