-- paquete genrico de una llista

generic

type elem is private;

package llista is

  type Llista is limited private;

  procedure Crear(L: in out Llista);
  procedure Copiar(Source: in Llista; Destination: in out Llista);
  procedure Afegir(L: in out Llista; P: in Elem);
  procedure Esborrar(L: in out Llista);
  procedure Primer(L: in out Llista);
  function Actual(L: in Llista) return Elem;
  procedure Seguent (L: in out Llista);
  function Queden(L: in Llista) return Boolean;
  function Esta_Creada(L: in Llista) return Boolean;
  function Existeix(L: in Llista; P: in Elem) return Boolean;
  procedure Modificar(L: in out Llista; AntigaP, P: in Elem);
  function Total(L: Llista) return integer; 
  procedure Alliberar_Memoria(L: in out Llista);
      

private

  type Node;
  type PNode is access Node;
  type Node is record
    P: Elem;
    Next: PNode := null;
  end record;

  type Llista is record
    Primer: PNode;
    Anterior: PNode;
    Total: integer := 0;
  end record;

end llista;
