-----------------------------
-- Programaci Concurrent  --
--                         --
-- 14-Dec-2001             --
--                         --
-- Sergio Gomez            --
-- Alex Arenas             --
-----------------------------

package body Moviments is

  ----------------
  -- Initialize --
  ----------------

  procedure Initialize(Object: in out Moviment) is
  begin
    Object.APM := new Protected_Moviment(Object.Seed);
    Object.APM.Init;
  end Initialize;

  -----------------------
  -- Moviment_Aleatori --
  -----------------------

  function Moviment_Aleatori(M: in Moviment) return Direccio is
    D: Direccio;
  begin
    M.APM.Generate(D);
    return D;
  end Moviment_Aleatori;

  ------------------------
  -- Protected_Moviment --
  ------------------------

  protected body Protected_Moviment is

    ----------
    -- Init --
    ----------

    procedure Init is
    begin
      if Seed = Random_Seed then
        Reset(G);
      else
        Reset(G, Seed);
      end if;
    end Init;

    --------------
    -- Generate --
    --------------

    procedure Generate(D: out Direccio) is
    begin
      D := Random(G);
    end Generate;

  end Protected_Moviment;

end Moviments;
