-----------------------------
-- Programaci Concurrent  --
--                         --
-- 14-Dec-2001             --
--                         --
-- Sergio Gomez            --
-- Alex Arenas             --
-----------------------------

with Ada.Finalization; use Ada.Finalization;
with Ada.Numerics.Discrete_Random;


package Moviments is

  --------------
  -- Direccio --
  --------------

  type Direccio is (Nord, Sud, Est, Oest);

  Direccio_Oposada: constant array(Direccio) of Direccio := (Sud, Nord, Oest, Est);

  --------------
  -- Moviment --
  --------------

  Random_Seed: constant Integer := 0;

  type Moviment(Seed: Integer := Random_Seed) is limited private;
  
  function Moviment_Aleatori(M: in Moviment) return Direccio;


private

  --------------
  -- Auxiliar --
  --------------

  package Random_Direccio is new Ada.Numerics.Discrete_Random(Direccio);
  use Random_Direccio;

  protected type Protected_Moviment(Seed: Integer := Random_Seed) is
    procedure Init;
    procedure Generate(D: out Direccio);
  private
    G: Generator;
  end Protected_Moviment;

  type Access_Protected_Moviment is access Protected_Moviment;

  --------------
  -- Moviment --
  --------------

  type Moviment(Seed: Integer := Random_Seed) is new Controlled with record
    APM: Access_Protected_Moviment(Seed);
  end record;
  
  procedure Initialize(Object: in out Moviment);

end Moviments;
