-----------------------------
-- Programaci Concurrent  --
--                         --
-- 20-Nov-2002             --
--                         --
-- Sergio Gomez            --
-- Alex Arenas             --
-----------------------------

with Ada.Numerics.Float_Random; use Ada.Numerics.Float_Random;

package body Sorpreses.Generador is


  Seed: Generator;

  function Posicio_Aleatoria(Num_Fil, Num_Col: in Positive) return Posicio is
    P: Posicio;
  begin
    P.Fil := 1 + (Integer(Float(Num_Fil) * Random(Seed)) mod Num_Fil);
    P.Col := 1 + (Integer(Float(Num_Col) * Random(Seed)) mod Num_Col);
    return P;
  end Posicio_Aleatoria;

  procedure Generar_Sorpresa(T: in out Tauler;
      Posicio_Sorpresa: out Posicio;
      Posicio_Pista: out Posicio;
      Valor_Sorpresa: out Integer;
      Instant_Inici_Sorpresa: out Time;
      Instant_Fi_Sorpresa: out Time) is
    Num_Fil, Num_Col: Positive;
    Obstacles, Menjacocos: LPosicions.Llista;
    P: Posicio;
  begin
    Num_Fil := Obtenir_Num_Fileres(T);
    Num_Col := Obtenir_Num_Columnes(T);
    Posicions_Obstacles(T, Obstacles);
    Posicions_Menjacocos(T, Menjacocos);
    loop
      P := Posicio_Aleatoria(Num_Fil, Num_Col);
      exit when (not LPosicions.Existeix(Obstacles, P)) and
                (not LPosicions.Existeix(Menjacocos, P));
    end loop;
    Posicio_Sorpresa := P;
    loop 
      P := Posicio_Aleatoria(Num_Fil, Num_Col);
      exit when (P /= Posicio_Sorpresa) and
                (not LPosicions.Existeix(Obstacles, P)) and
                (not LPosicions.Existeix(Menjacocos, P));
    end loop;
    Posicio_Pista:= P;
    Valor_Sorpresa := -20 + (Integer(41.0 * Random(Seed)) mod 41);
    Instant_Inici_Sorpresa := Clock + To_Time_Span(2.5);
    Instant_Fi_Sorpresa := Instant_Inici_Sorpresa + To_Time_Span(10.0);

    LPosicions.Alliberar_Memoria(Obstacles);
    LPosicions.Alliberar_Memoria(Menjacocos);
  end Generar_Sorpresa;

begin
  Reset(Seed);

end Sorpreses.Generador;
