-----------------------------
-- Programaci Concurrent  --
--                         --
-- 20-Nov-2002             --
--                         --
-- Sergio Gomez            --
-- Alex Arenas             --
-----------------------------

with Sorpreses.Generador; use Sorpreses.Generador;

package body Sorpreses is
  
  -- Tasca que generara una sorpresa cada X tiempo y la quitara al Y tiempo
  task body Sor is
    PosSor, PosPista: Posicio;
    Valor: Integer;
    Ini, Fi: Time;
    acabar: boolean := false;
  begin
    loop
      -- Esperamos a que nos dejen comenzar
      accept start do
        null;
      end start;
      
      while not (acabar) loop
        Generar_Sorpresa(T.ALL, PosSor, PosPista, Valor, Ini, Fi);

        -- Mientras esperamos a poner la sorpresa, si nos ordenan acabar....
        select
          accept theEnd do
            acabar := true;
          end theEnd;
        or
          delay until Ini;
        end select;

        -- Salimos
        if (acabar) then
          exit;
        end if;
        
        Afegir_Sorpresa(T.ALL, PosSor, PosPista, Valor);
        
        -- Mientras esperamos a poner la sorpresa, si nos ordenan acabar....
        select
          accept theEnd do
            acabar := true;
          end theEnd;
        or
          delay until Fi;
        end select;
        
        Retirar_Sorpresa(T.ALL);

      end loop;
      acabar := false;
      
    end loop;
  end Sor;

end Sorpreses;
