with Glib;              use Glib;
with Double_Buffer;     use Double_Buffer;
with Gtk.Window;        use Gtk.Window;
with Gtk.Label;         use Gtk.Label;
with Gtk.Fixed;         use Gtk.Fixed;
with Ada.Real_Time; use Ada.Real_Time;
with Parametros; use Parametros;

package TableroVisual is

  type TableroVisualRecord is private;
  type PTableroVisualRecord is access TableroVisualRecord;
  
  function Config return String;
  procedure Init(T: in out TableroVisualRecord; Anchura: in Gint; Altura: in Gint);
  procedure Draw_Tablero (T: TableroVisualRecord);
  procedure Draw_ComeCoco (T: in TableroVisualRecord; X, Y: Gint; Ident: in integer);
  procedure Draw_Obstaculo (T: in TableroVisualRecord; X, Y: Gint);
  procedure Draw_Coco (T: in TableroVisualRecord; X, Y: Gint);
  procedure Draw_Vitamina (T: in TableroVisualRecord; X, Y: Gint);
  procedure Draw_Huevo (T: in TableroVisualRecord; X, Y: Gint);
  procedure Draw_Sorpresa (T: in TableroVisualRecord; X, Y: Gint);
  procedure Draw_Pista (T: in TableroVisualRecord; X, Y: Gint);
  procedure Draw_Casilla (T: in TableroVisualRecord; X, Y: Gint);
  procedure Actualizar(T:  TableroVisualRecord);
  
  procedure AfegirMenjacocos(T: in out TableroVisualRecord);
  procedure TreureTotsMenjacocos(T: in out TableroVisualRecord);
  procedure ActualitzarMenjacocos(T: in out TableroVisualRecord; ID, Punts, Caselles: in integer; Periodo: in Time_Span);
  procedure ActualitzarTotal(T: in out TableroVisualRecord; Punts: integer);
  
  procedure AfegirPartida(T: in out TableroVisualRecord; Punts: integer);
  procedure ActualitzarPuntuacioMitja(T: in out TableroVisualRecord; Punts: float);
  
  private
    
    type EtiquetasComecocos is array (0..MaxMenjaCocos-1) of Gtk_Label;
    type EtiquetasPartida is array (0..MaxPartides-1) of Gtk_Label;
    type TableroVisualRecord is record
      Window, StatusWindow  : Gtk_Window;
      Buffer : Gtk_Double_Buffer;
      EstadoComecocos: EtiquetasComecocos;
      EstadoParidas: EtiquetasPartida;
      PuntsTotals: Gtk_Label;
      PuntuacioMitja: Gtk_Label;
      TotalMenjaCocos, TotalPartidas: integer:=0; -- Quants menjacocos/partides?
                                   -- Quant s'utilitza per afegir: sempre apunta al primer espai lliure
      FixedStatus: Gtk_Fixed; -- Per afegir noves labels
      Altura: Gint;
      Anchura: Gint;
    end record;
end TableroVisual;
