-----------------------------
-- Programaci Concurrent  --
--                         --
-- 20-Nov-2002             --
--                         --
-- Sergio Gomez            --
-- Alex Arenas             --
-----------------------------
with Glib; use Glib;
with Sounds; use Sounds;

package body Taulers is


  protected body Tauler is
  
    -- Actualiza area de dibujo
    procedure ActualizarDibujo is
    begin
      Actualizar(TVisual);
    end ActualizarDibujo;
    -------------------------
    -- Obtenir_Num_Fileres --
    -------------------------
  
    function Obtenir_Num_Fileres return Positive is
    begin
      return tauler'length(2);
    end Obtenir_Num_Fileres;
  
    --------------------------
    -- Obtenir_Num_Columnes --
    --------------------------
  
    function Obtenir_Num_Columnes return Positive is
    begin
      return tauler'length(1);
    end Obtenir_Num_Columnes;
  
    -------------------------
    -- Posicions_Obstacles --
    -------------------------
  
    procedure Posicions_Obstacles(L: out LPosicions.Llista) is
      x,y : Positive :=1;
      P: Posicio;
    begin
      LPosicions.Crear(L);
      for x in 1..tauler'length(1) loop
        for y in 1..tauler'length(2) loop
          if tauler(x,y) = symObstacle then
            P.Col := x;
            P.Fil := y;
            LPosicions.Afegir(L, P);
          end if;
        end loop;
      end loop;
    end Posicions_Obstacles;
  
    --------------------------
    -- Posicions_Menjacocos --
    --------------------------
  
    procedure Posicions_Menjacocos(L: out LPosicions.Llista) is
      S: status;
    begin
      LStatus.Primer(menjacocos);
      LPosicions.Crear(L);
      while (LStatus.Queden(menjacocos)) loop
        S := LStatus.Actual(menjacocos);
        Lposicions.Afegir(L, S.Pos);
        LStatus.Seguent(menjacocos);
      end loop;
    end Posicions_Menjacocos;

    --------------------------
    -- Posicions_Ous --
    --------------------------
    
    procedure Posicions_Ous(L: out LPosicions.Llista) is
      x,y : Positive :=1;
      P: Posicio;
    begin
      LPosicions.Crear(L);
      for x in 1..tauler'length(1) loop
        for y in 1..tauler'length(2) loop
          if tauler(x,y) = symOu then
            P.Col := x;
            P.Fil := y;
            if  (LPosicions.Esta_Creada(ousDolents)) then
              if (not LPosicions.Existeix(ousDolents, P)) then
                LPosicions.Afegir(L, P);
              end if;
            else 
              LPosicions.Afegir(L, P);
            end if;
          end if;
        end loop;
      end loop;
    end Posicions_Ous;
    
    --------------------------
    -- Posicions_Vitamines --
    --------------------------
    
    procedure Posicions_Vitamines(L: out LPosicions.Llista) is
      x,y : Positive :=1;
      P: Posicio;
    begin
      LPosicions.Crear(L);
      for x in 1..tauler'length(1) loop
        for y in 1..tauler'length(2) loop
          if tauler(x,y) = symVitamina then
            P.Col := x;
            P.Fil := y;
            if  (LPosicions.Esta_Creada(vitaminesDolentes)) then
              if (not LPosicions.Existeix(vitaminesDolentes, P)) then
                LPosicions.Afegir(L, P);
              end if;
            else
              LPosicions.Afegir(L, P);
            end if;
          end if;
        end loop;
      end loop;
    end Posicions_Vitamines;

    --------------------------
    -- Posicions_Cocos --
    --------------------------
    
    procedure Posicions_Cocos(L: out LPosicions.Llista) is
      x,y : Positive :=1;
      P: Posicio;
    begin
      LPosicions.Crear(L);
      for x in 1..tauler'length(1) loop
        for y in 1..tauler'length(2) loop
          if tauler(x,y) = symCoco then
            P.Col := x;
            P.Fil := y;
            LPosicions.Afegir(L, P);
          end if;
        end loop;
      end loop;
    end Posicions_Cocos;

    
    function Total_Menjacocos return integer is
    begin
      return totalMenjacocos;
    end Total_Menjacocos;
    
    ---------------------
    -- Afegir_Sorpresa --
    ---------------------
  
    procedure Afegir_Sorpresa(Posicio_Sorpresa: in Posicio;
        Posicio_Pista: in Posicio; Valor_Sorpresa: in Integer) is
      id : integer;
      S, newS: status;
    begin
      posSorpresa := Posicio_Sorpresa;
      posPista := Posicio_Pista;
      valorSorpresa := Valor_Sorpresa;
      sorpresa := True;
      pista := true;
      Draw_Sorpresa(TVisual, Gint(posSorpresa.Col), Gint(posSorpresa.Fil));
      Draw_Pista(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
      
      -- Si despres d'haver calculat la posicio de la sopresa el generador
      -- podria ser que hi hagues un menjacocos en aquesta casella. Encara
      -- que el generador comprova que no hi hagui cap comecocos en la posicio
      -- generada, la situaci podria cambiar fins que es transmet la posicio
      -- de la sorpresa/pista al tauler.
      LStatus.Primer(menjacocos);
      id := 0;
      while (LStatus.Queden(menjacocos)) loop
        S:= LStatus.Actual(menjacocos);
        -- La sorpresa ha aparegut al damunt d'un menjacocos
        if (S.Pos = posSorpresa) then
          if (valorSorpresa > 0) then
            Sounds.sorpresa;
          else
            Sounds.sorpresaMala;
          end if;
          -- El menjacocos agafa la sorpresa (cambien puntuacio, no posicio ni
          -- caselles ja que no ha sigut per moviment del menjacocos)
          totalPunts := totalPunts + valorSorpresa;
          newS.Punts := S.Punts + valorSorpresa;
          newS.Caselles := S.Caselles;
          newS.Pos := S.Pos;
          
          sorpresa := false;
          pista := false;
          sorDolenta := True; -- Torna a ser dolenta
          
          -- Tornem a dibuixar el menjacoco en la posicio
          Draw_ComeCoco(TVisual, Gint(S.Pos.Col), Gint(S.Pos.Fil), id);
          
          LStatus.Modificar(menjacocos, S, newS);
          
          -- Hem de retirar la pista tb del tauler visual
          if tauler(posPista.Col,posPista.Fil) = symCoco then
            Draw_Coco(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
          elsif tauler(posPista.Col,posPista.Fil) = symVitamina then
            Draw_Coco(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
          elsif tauler(posPista.Col,posPista.Fil) = symOu then
            Draw_Huevo(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
          else
            Draw_Casilla(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
          end if;
          
        elsif (S.Pos = posPista) then
          -- La pista ha caigut al damnut d'un menjacocos

          Sounds.pista;
          -- Ahora ya podemos saber si la sorpresa es buena o no
          -- (por defecto es mala).
          if (sorpresa) and (valorSorpresa > 0) then
            sorDolenta := false;
          end if;
          pista := false;
          
          -- Redibuixem casella amb el menjacocos
          Draw_ComeCoco(TVisual, Gint(S.Pos.Col), Gint(S.Pos.Fil), id);
        end if;
        LStatus.Seguent(menjacocos);
        id := id+1;
      end loop;
      
    end Afegir_Sorpresa;
  
    ----------------------
    -- Retirar_Sorpresa --
    ----------------------
  
    procedure Retirar_Sorpresa is
      S: status;
      id: integer := 0;
    begin
      sorpresa := False;
      pista := false;
      sorDolenta := True; -- Torna a ser dolenta fins que no es demostri lo contrari
      
      if tauler(posSorpresa.Col,posSorpresa.Fil) = symCoco then
        Draw_Coco(TVisual, Gint(posSorpresa.Col), Gint(posSorpresa.Fil));
      elsif tauler(posSorpresa.Col,posSorpresa.Fil) = symVitamina then
        Draw_Coco(TVisual, Gint(posSorpresa.Col), Gint(posSorpresa.Fil));
      elsif tauler(posSorpresa.Col,posSorpresa.Fil) = symOu then
        Draw_Huevo(TVisual, Gint(posSorpresa.Col), Gint(posSorpresa.Fil));
      else
        Draw_Casilla(TVisual, Gint(posSorpresa.Col), Gint(posSorpresa.Fil));
      end if;

            
      if tauler(posPista.Col,posPista.Fil) = symCoco then
        Draw_Coco(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
      elsif tauler(posPista.Col,posPista.Fil) = symVitamina then
        Draw_Coco(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
      elsif tauler(posPista.Col,posPista.Fil) = symOu then
        Draw_Huevo(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
      else
        Draw_Casilla(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
      end if;
      
      -- Si hay un comecocos que acaba de comer la sorpresa, se acaba la partida
      -- y la sorpresa se retira a los pocos segundos, borraria al comecoco, asi
      -- que aqui lo restablecemos. (Esta es la solucion de un bug encontrado)
      LStatus.Primer(menjacocos);
      id := 0;
      while (LStatus.Queden(menjacocos)) loop
        S:= LStatus.Actual(menjacocos);
        if (S.Pos = posSorpresa) then
          Draw_ComeCoco(TVisual, Gint(S.Pos.Col), Gint(S.Pos.Fil), id);
        elsif (S.Pos = posPista) then
          Draw_ComeCoco(TVisual, Gint(S.Pos.Col), Gint(S.Pos.Fil), id);
        end if;
        LStatus.Seguent(menjacocos);
        id := id+1;
      end loop;
      
    end Retirar_Sorpresa;
    
    -----------------
    -- Valor_Sorpresa --
    -----------------
    function Valor_Sorpresa return integer is
    begin
      return valorSorpresa;
    end Valor_Sorpresa;

    -----------------
    -- Posicio_Pista --
    -----------------
    function Posicio_Pista return Posicio is
    begin
      return posPista;
    end Posicio_Pista;
    
    -------------------
    -- Posicio_Sorpresa --
    -------------------
    function Posicio_Sorpresa return Posicio is
    begin
      return posSorpresa;
    end Posicio_Sorpresa;
    
    ------------------
    -- Hi_Ha_Sorpresa --
    ------------------
    function Hi_Ha_Sorpresa return boolean is
    begin
      return sorpresa;
    end Hi_Ha_Sorpresa;
    
    function Hi_Ha_Pista return boolean is
    begin
      return pista;
    end Hi_Ha_Pista;
    
    function SorpresaDolenta return boolean is
    begin
      return sorDolenta;
    end SorpresaDolenta;
    
    -------------------
    -- Buscar_Menjacoco--
    -------------------
    -- procedure Buscar_Menjacoco  () is
    -- begin
    -- -- S'ha de buscar el menjacoco que estigui ms aprop de la posici donada, --
    -- -- calculant els moviments que li caldria fer fins a arribar a aquesta posici. --
    -- end Buscar_Menjacoco;
    
    procedure Afegir_Elem(P: in Posicio; Elem: in character) is
      elem_incorrecte: exception;
    begin
      if Elem = symObstacle then
        Draw_Obstaculo(TVisual, Gint(P.Col), Gint(P.Fil));
      elsif Elem = symVitamina  then
        Draw_Vitamina(TVisual, Gint(P.Col), Gint(P.Fil));
      elsif Elem = symOu then
        Draw_Huevo(TVisual, Gint(P.Col), Gint(P.Fil));
      elsif Elem = symCoco then
        Draw_Coco(TVisual, Gint(P.Col), Gint(P.Fil));
      else
          raise elem_incorrecte;
      end if;
      tauler(P.Col, P.Fil) := Elem;
      iniTauler(P.Col, P.Fil) := Elem;
    end Afegir_Elem;
    
    procedure setValors(Coco, Vitamina, Ou: in Integer) is
    begin
      valorCoco := Coco;
      valorVitamina := Vitamina;
      valorOu := Ou;
    end setValors;
    
    function getValorCoco return Integer is
    begin
      return valorCoco;
    end getValorCoco;
    
    function getValorVitamina return Integer is
    begin
      return valorVitamina;
    end getValorVitamina;
    
    function getValorOu return Integer is
    begin
      return valorOu;
    end getValorOu;
    
    procedure Afegir_OuDolent(P: in Posicio) is
    begin
      if not (LPosicions.Esta_Creada(ousDolents)) then
        LPosicions.Crear(ousDolents);
      end if;
      LPosicions.Afegir(ousDolents, P);
    end Afegir_OuDolent;
    
    procedure Afegir_VitaminaDolenta(P: in Posicio) is
    begin
      if not (LPosicions.Esta_Creada(vitaminesDolentes)) then
        LPosicions.Crear(vitaminesDolentes);
      end if;
      LPosicions.Afegir(vitaminesDolentes, P);
    end Afegir_VitaminaDolenta;
    
    procedure Afegir_Menjacocos(P: in Posicio; incubado: in boolean) is
      S: status;
    begin
      totalMenjacocos := totalMenjacocos + 1;
      if not (LStatus.Esta_Creada(menjacocos)) then
        LStatus.Crear(menjacocos);
        LPosicions.Crear(iniMenjacocos); -- Nos servira para resetear los comecocos a sus posiciones iniciales
      end if;
      
      -- Ficar punter al final per afegir
      while LStatus.Queden(menjacocos) loop
        LStatus.Seguent(menjacocos);
      end loop;

      -- Si el comecoco es creado por incubacion, no lo aadimos a la lista
      -- de comecocos iniciales.
      if not (incubado) then
        -- Ficar punter al final per afegir
        while LPosicions.Queden(iniMenjacocos) loop
          LPosicions.Seguent(iniMenjacocos);
        end loop;
      end if;
      S.Pos := P;
      S.Punts := 0;
      S.Caselles := 0;
      LStatus.Afegir(menjacocos, S);
      
      if not (incubado) then
        LPosicions.Afegir(iniMenjacocos, P);
        totalIniMenjacocos := totalIniMenjacocos + 1;
      end if;
      -- El identificador del comecocos es la posicin que ocupa en la lista
      -- (la primera posicin se considera el 0 por eso restamos -1)
      Draw_ComeCoco(TVisual, Gint(P.Col), Gint(P.Fil), LStatus.Total(menjacocos)-1);
      -- Aadimos una nueva entrada (label) en la ventana status
      AfegirMenjacocos(TVisual);
    end Afegir_Menjacocos;
    

    procedure Modificar_Menjacocos(AntigaP, P: in Posicio; incubado: out boolean; Periodo: in Time_Span) is
      oldS, S: status;
      id: integer:=0; -- En ajudara a trobar l'identificador del comecoco per
                      -- utilitzaro amb la finestra d'Status. L'id no es ms
                      -- que la posici que ocupa el menjacocos a la llista.
    begin
      -- Busquem el node status corresponent a la posicio antiga
      LStatus.Primer(menjacocos);
      while (LStatus.Queden(menjacocos)) loop
        oldS := LStatus.Actual(menjacocos);
        if (oldS.Pos = antigaP) then
          exit; -- Trobat el node (esta contingut en oldS)
        end if;
        LStatus.Seguent(menjacocos);
        id := id + 1;
      end loop;
      
      S.Pos := P;
      -- Aumentem el nombre de caselles visitades
      S.Caselles := oldS.Caselles + 1;
      S.Punts := oldS.Punts;
      -- Incrementar puntuacions segons que hem menjat
      -- Si nos hemos comido la sorpresa
      if ((sorpresa) and (P = posSorpresa)) then
        if (valorSorpresa > 0) then
          Sounds.sorpresa;
        else
          Sounds.sorpresaMala;
        end if;
        totalPunts := totalPunts + valorSorpresa;
        S.Punts := oldS.Punts + valorSorpresa;
        sorpresa := false;
        pista := false;
        sorDolenta := True; -- Torna a ser dolenta

        -- Retiramos Sorpresa del tablero visual
        if tauler(posSorpresa.Col,posSorpresa.Fil) = symCoco then
          Draw_Coco(TVisual, Gint(posSorpresa.Col), Gint(posSorpresa.Fil));
        elsif tauler(posSorpresa.Col,posSorpresa.Fil) = symVitamina then
          Draw_Coco(TVisual, Gint(posSorpresa.Col), Gint(posSorpresa.Fil));
        elsif tauler(posSorpresa.Col,posSorpresa.Fil) = symOu then
          Draw_Huevo(TVisual, Gint(posSorpresa.Col), Gint(posSorpresa.Fil));
        else
          Draw_Casilla(TVisual, Gint(posSorpresa.Col), Gint(posSorpresa.Fil));
        end if;
  
        -- Retiramos Pista del tablero visual
        if tauler(posPista.Col,posPista.Fil) = symCoco then
          Draw_Coco(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
        elsif tauler(posPista.Col,posPista.Fil) = symVitamina then
          Draw_Coco(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
        elsif tauler(posPista.Col,posPista.Fil) = symOu then
          Draw_Huevo(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
        else
          Draw_Casilla(TVisual, Gint(posPista.Col), Gint(posPista.Fil));
        end if;
      -- Si nos hemos comido la pista
      elsif ((sorpresa) and (P = posPista)) then
        Sounds.pista;
        -- Ahora ya podemos saber si la sorpresa es buena o no
        -- (por defecto es mala)
        if (valorSorpresa > 0) then
          sorDolenta := false;
        end if;
        pista := false;
      end if;
      -- Ademas de la sorpresa/pista, en esa posicin quizas habia un
      -- coco o vitamina que tb nos hemos comido, asi que lo contabilizamos:
      
      -- Si nos hemos comido un coco
      if (tauler(P.Col, P.Fil) = symCoco) then
        Sounds.coco;
        totalPunts := totalPunts + valorCoco;
        S.Punts := oldS.Punts + valorCoco;
      -- Si nos hemos comido una vitamina
      elsif (tauler(P.Col, P.Fil) = symVitamina) then
        Sounds.vitamina;
        totalPunts := totalPunts + valorVitamina;
        S.Punts := oldS.Punts + valorVitamina;
      end if;
      
      LStatus.Modificar(menjacocos, oldS, S);

      -- Si hemos estado encima de un huevo, es que hemos estado incubando
      if (tauler(AntigaP.Col, AntigaP.Fil) = symOu) then
        Sounds.huevo;
        incubado := true;
      else
        incubado := false;
      end if;

      -- Se ha comido el coco/vitamina/huevo o lo que hubiese
      tauler(AntigaP.Col, AntigaP.Fil) := ' ';
      Draw_Casilla(TVisual, Gint(AntigaP.Col), Gint(AntigaP.Fil));
      Draw_ComeCoco(TVisual, Gint(P.Col), Gint(P.Fil), id);
      -- Actualizar ventana de status
      ActualitzarTotal(TVisual, totalPunts);
      ActualitzarMenjacocos(TVisual, id, S.Punts, S.Caselles, Periodo);
    end Modificar_Menjacocos;
    
    
    -- Reinicia el tablero, volviendo a dibujar todos sus elementos, actualizando
    -- su lista interna de estado a las posiciones originales + puntuacion cero +
    -- + casillas cero. Dibuja los comecocos iniciales en pantalla tb.
    procedure Reset is
      elem_incorrecte: exception;
      S: status;
      id: integer;
    begin
      Sounds.finPartida;
      -- Dibujamos el tablero vacio
      Draw_Tablero(TVisual);
      -- Recuperamos el tablero inicial (cocos, obstaculos, vitaminas y huevos)
      tauler := iniTauler;
      -- Lo dibujamos
      for x in 1..tauler'length(1) loop
        for y in 1..tauler'length(2) loop
          
          if tauler(x, y) = symObstacle then
            Draw_Obstaculo(TVisual, Gint(x), Gint(y));
          elsif tauler(x, y) = symVitamina  then
            Draw_Vitamina(TVisual, Gint(x), Gint(y));
          elsif tauler(x, y) = symOu then
            Draw_Huevo(TVisual, Gint(x), Gint(y));
          elsif tauler(x, y) = symCoco then
            Draw_Coco(TVisual, Gint(x), Gint(y));
          else
              raise elem_incorrecte;
          end if;
        end loop;
      end loop;
      
      totalMenjacocos := totalIniMenjacocos;
      
      AfegirPartida(TVisual, totalPunts);
      puntsAcumulats := puntsAcumulats + totalPunts;
      resets := resets+1;
      ActualitzarPuntuacioMitja(TVisual, float(puntsAcumulats)/float(resets));
      -- Reseteamos la puntuacion total
      totalPunts := 0;
      ActualitzarTotal(TVisual, totalPunts);
      -- Eliminamos de la ventana de estado todas las etiquetas sobre comecocos
      TreureTotsMenjacocos(TVisual);
      
      -- Reiniciem la llista de posicions de ous i vitamines dolentes (es troben atrapades)
      if (LPosicions.Esta_Creada(ousDolents)) then
        LPosicions.Alliberar_Memoria(ousDolents);
        LPosicions.Crear(ousDolents);
      end if;
      if (LPosicions.Esta_Creada(vitaminesDolentes)) then
        LPosicions.Alliberar_Memoria(vitaminesDolentes);
        LPosicions.Crear(vitaminesDolentes);
      end if;
      
      -- Borramos nuestra lista de estado (pos, punts, caselles) de los comecocos
      LStatus.Alliberar_Memoria(menjacocos);
      -- Y creamos una nueva con los puntos y casillas a 0, y con las posiciones
      -- iniciales de los comecocos. Ademas los dibujamos en pantalla.
      LStatus.Crear(menjacocos);
      LPosicions.Primer(iniMenjacocos);
      id:=0;  -- Identificador que se mostrar en el dibujo del comecoco
      while (LPosicions.Queden(iniMenjacocos)) loop
        S.Pos := LPosicions.Actual(iniMenjacocos);
        S.Punts := 0;
        S.Caselles := 0;
        -- El identificador del comecocos es la posicin que ocupa en la lista
        Draw_ComeCoco(TVisual, Gint(S.Pos.Col), Gint(S.Pos.Fil), id);
        -- Aadimos una nueva entrada (label) en la ventana status
        AfegirMenjacocos(TVisual);
        -- Aadimos label en la ventana de estado
        LStatus.Afegir(menjacocos, S);
        LPosicions.Seguent(iniMenjacocos);
        id := id +1;
      end loop;
    end Reset;
    
  end Tauler;
  
  -------------------------------------------------------------
  -------------------------------------------------------------
  procedure ActualizarDibujo(T: in out Tauler) is
  begin
    T.ActualizarDibujo;
  end ActualizarDibujo;
  
  procedure Afegir_OuDolent(T: in out Tauler; P: in Posicio) is
  begin
    T.Afegir_OuDolent(P);
  end Afegir_OuDolent;
  
  procedure Afegir_VitaminaDolenta(T: in out Tauler; P: in Posicio) is
  begin
    T.Afegir_VitaminaDolenta(P);
  end Afegir_VitaminaDolenta;
  
  function Obtenir_Num_Fileres(T: in Tauler) return Positive is
  begin
    return T.Obtenir_Num_Fileres;
  end Obtenir_Num_Fileres;
  
  function Obtenir_Num_Columnes(T: in Tauler) return Positive is
  begin
    return T.Obtenir_Num_Columnes;
  end Obtenir_Num_Columnes;

  procedure Posicions_Obstacles(T: in out Tauler; L: out LPosicions.Llista) is
  begin
    T.Posicions_Obstacles(L);
  end Posicions_Obstacles;
  
  procedure Posicions_Menjacocos(T: in out Tauler; L: out LPosicions.Llista) is
  begin
    T.Posicions_Menjacocos(L);
  end Posicions_Menjacocos;

  procedure Posicions_Ous(T: in out Tauler; L: out LPosicions.Llista) is
  begin
    T.Posicions_Ous(L);
  end Posicions_Ous;
  
  procedure Posicions_Vitamines(T: in out Tauler; L: out LPosicions.Llista) is
  begin
    T.Posicions_Vitamines(L);
  end Posicions_Vitamines;
  
  procedure Posicions_Cocos(T: in out Tauler; L: out LPosicions.Llista) is
  begin
    T.Posicions_Cocos(L);
  end Posicions_Cocos;
  
  function Total_Menjacocos(T: Tauler) return integer is
  begin
    return T.Total_Menjacocos;
  end Total_Menjacocos;
  
  function Valor_Sorpresa(T: Tauler) return integer is
  begin
    return T.Valor_Sorpresa;
  end Valor_Sorpresa;
  
  function Posicio_Pista(T: Tauler) return Posicio is
  begin
    return T.Posicio_Pista;
  end Posicio_Pista;
  
  function Posicio_Sorpresa(T: Tauler) return Posicio is
  begin
    return T.Posicio_Sorpresa;
  end Posicio_Sorpresa;
  
  function Hi_Ha_Sorpresa(T: Tauler) return boolean is
  begin
    return T.Hi_Ha_Sorpresa;
  end Hi_Ha_Sorpresa;
  
  function Hi_Ha_Pista(T: Tauler) return boolean is
  begin
    return T.Hi_Ha_Pista;
  end Hi_Ha_Pista;
  
  function SorpresaDolenta(T: Tauler) return boolean is
  begin
    return T.SorpresaDolenta;
  end SorpresaDolenta;
  
  procedure Afegir_Sorpresa(T: in out Tauler; Posicio_Sorpresa: in Posicio;
    Posicio_Pista: in Posicio; Valor_Sorpresa: in Integer) is
  begin
    T.Afegir_Sorpresa(Posicio_Sorpresa, Posicio_Pista, Valor_Sorpresa);
  end Afegir_Sorpresa;
  
  procedure Retirar_Sorpresa(T: in out Tauler) is
  begin
    T.Retirar_Sorpresa;
  end Retirar_Sorpresa;
  
  procedure Afegir_Elem(T:in out Tauler; P: in Posicio; Elem: in character) is
  begin
    T.Afegir_Elem(P, Elem);
  end Afegir_Elem;
  
  procedure setValors(T: in out Tauler; Coco, Vitamina, Ou: in Integer) is
  begin
    T.setValors(Coco, Vitamina, Ou);
  end setValors;
  
  function getValorCoco(T: in Tauler) return Integer is
  begin
    return T.getValorCoco;
  end getValorCoco;
  
  function getValorVitamina(T: in Tauler) return Integer is
  begin
    return T.getValorVitamina;
  end getValorVitamina;
  
  function getValorOu(T: in Tauler) return Integer is
  begin
    return T.getValorOu;
  end getValorOu;
  
  procedure Afegir_Menjacocos(T: in out Tauler; P: in Posicio; incubado: in boolean) is
  begin
    T.Afegir_Menjacocos(P, incubado);
  end Afegir_Menjacocos;
  
  procedure Modificar_Menjacocos(T: in out Tauler; AntigaP, P: in Posicio; incubado: out boolean; Periodo: in Time_Span) is
  begin
    T.Modificar_Menjacocos(AntigaP, P, incubado, Periodo);
  end Modificar_Menjacocos;
  
  procedure Reset(T: in out Tauler) is
  begin
    T.Reset;
  end Reset;
  
end Taulers;

